# Copyright (C) 1997-1998 Four J's Development Tools

DATABASE pb

GLOBALS "globals.4gl"

FUNCTION browseCompanies()

  DEFINE exitWhile SMALLINT  
  DEFINE counter INTEGER
  DEFINE tableRow INTEGER
  DEFINE sqlTxt CHAR(1000)
  DEFINE r_fetch RECORD LIKE company.*
  DEFINE ra_display ARRAY[1000] OF RECORD
           company_id INTEGER,
           company_name CHAR(50),
           company_tel CHAR(30),
           company_fax CHAR(30),
           company_email CHAR(40)
         END RECORD

  OPEN WINDOW frmListCompanyWindow AT 4, 4                                           
    WITH 80 ROWS, 90 COLUMNS
    ATTRIBUTES (BORDER)

  OPEN FORM frmListCompany FROM "flcomp"
  DISPLAY FORM frmListCompany
  
  LET exitWhile = FALSE
  WHILE exitWhile = FALSE
    LET sqlTxt = "SELECT * FROM company ORDER BY com_name"
    LET counter = 0
    PREPARE sqlStatementCom FROM sqlTxt
    DECLARE ptrResultCom CURSOR FOR sqlStatementCom
    OPEN ptrResultCom
    FETCH ptrResultCom INTO r_fetch.*
    WHILE status != NOTFOUND
      LET counter = counter + 1
      LET ra_display[counter].company_id = r_fetch.com_id
      LET ra_display[counter].company_name = r_fetch.com_name
      LET ra_display[counter].company_tel = r_fetch.com_tel
      LET ra_display[counter].company_fax = r_fetch.com_fax
      LET ra_display[counter].company_email = r_fetch.com_email
      FETCH ptrResultCom INTO r_fetch.*
    END WHILE
  
    CALL SET_COUNT(counter)
    LET INT_FLAG = FALSE
    LET exitWhile = TRUE
    DISPLAY ARRAY ra_display TO scr.*
      ON KEY (F3)
        LET exitWhile = FALSE
        CALL newCompany()
        EXIT DISPLAY
    END DISPLAY
  END WHILE

  IF INT_FLAG = FALSE THEN
    # Display a full window with Company's information
    LET tableRow = ARR_CURR()
    CALL showCompany(ra_display[tableRow].company_id)
  END IF

  FREE sqlStatementCom
  FREE ptrResultCom

  CLOSE WINDOW frmListCompanyWindow

END FUNCTION

FUNCTION browseContacts(l_com_id)

  DEFINE l_com_id INTEGER

  DEFINE exitWhile SMALLINT
  DEFINE company_name CHAR(50)
  DEFINE counter INTEGER
  DEFINE tableRow INTEGER
  DEFINE sqlTxt CHAR(1000)
  DEFINE r_fetch RECORD LIKE contact.*
  DEFINE ra_display ARRAY[1000] OF RECORD
           contact_id INTEGER,
           contact_name CHAR(90),
           contact_tel CHAR(30),
           contact_fax CHAR(30),
           contact_email CHAR(40)
         END RECORD

  OPEN WINDOW frmListContactWindow AT 9, 2                                           
    WITH 100 ROWS, 100 COLUMNS
    ATTRIBUTES (BORDER)

  OPEN FORM frmListContact FROM "flctct"
  DISPLAY FORM frmListContact

  LET exitWhile = FALSE
  WHILE exitWhile = FALSE
    IF l_com_id = 0 THEN
      LET INT_FLAG = FALSE
      INPUT BY NAME company_name
        ON KEY (F2)
          CALL newContact(0)
      END INPUT
      IF INT_FLAG=TRUE THEN
        # No Company selected, assuming all
        LET company_name="All"
      END IF
      
      CASE company_name
        WHEN "All"
          LET sqlTxt = "SELECT * FROM contact"
        OTHERWISE
          LET sqlTxt = "SELECT contact.* FROM contact, company ",
                       "WHERE contact.ctc_com_id = company.com_id ",
                       "AND company.com_name MATCHES \"", company_name CLIPPED,
                       "\""
      END CASE
    ELSE
      SELECT company.com_name INTO company_name
        FROM company
        WHERE company.com_id = l_com_id
      LET sqlTxt = "SELECT contact.* FROM contact ",
                   "WHERE contact.ctc_com_id = ", l_com_id
    END IF
    
    DISPLAY company_name TO company_name
  
    LET counter = 0
    PREPARE sqlStatementCtc FROM sqlTxt
    DECLARE ptrResultCtc CURSOR FOR sqlStatementCtc
    OPEN ptrResultCtc
    FETCH ptrResultCtc INTO r_fetch.*
    WHILE status != NOTFOUND
      LET counter = counter + 1
      LET ra_display[counter].contact_id = r_fetch.ctc_id
      LET ra_display[counter].contact_name = r_fetch.ctc_title CLIPPED, " ", 
                                             r_fetch.ctc_first CLIPPED, " ",
                                             r_fetch.ctc_middle CLIPPED, " ",
                                             r_fetch.ctc_last CLIPPED, " ",
                                             r_fetch.ctc_suffix CLIPPED
      LET ra_display[counter].contact_tel = r_fetch.ctc_tel
      LET ra_display[counter].contact_fax = r_fetch.ctc_fax
      LET ra_display[counter].contact_email = r_fetch.ctc_email
      FETCH ptrResultCtc INTO r_fetch.*
    END WHILE

    CALL SET_COUNT(counter)
    LET INT_FLAG = FALSE
    LET exitWhile = TRUE
    DISPLAY ARRAY ra_display TO scr.*
      ON KEY (F2)
        LET exitWhile = FALSE
        CALL newContact(0)
        EXIT DISPLAY
    END DISPLAY
  END WHILE

  IF INT_FLAG = FALSE THEN                                                      
    # Display a full window with contact's information                          
    LET tableRow = ARR_CURR()                                                   
    CALL showContact(ra_display[tableRow].contact_id)                           
  END IF

  FREE sqlStatementCtc
  FREE ptrResultCtc

  CLOSE WINDOW frmListContactWindow

END FUNCTION

